<?php
/**
 * DokuWiki Media Manager Popup
 *
 * @author   Andreas Gohr <andi@splitbrain.org>
 * @license  GPL 2 (http://www.gnu.org/licenses/gpl.html)
 */
// must be run from within DokuWiki
if (!defined('DOKU_INC')) die();
if (!function_exists('tpl_includeFile')) {
  function tpl_includeFile($file) {
    include dirname(__FILE__).'/'.$file;
  }
}

// tpl_incdir(), tpl_basedir() and tpl_getMediaFile() code is c&p from:
// http://xref.dokuwiki.org/reference/dokuwiki/nav.html?inc/template.php.source.html
// and
// http://xref.dokuwiki.org/reference/dokuwiki/nav.html?inc/template.php.source.html
if (!function_exists('tpl_incdir')) {
  function tpl_incdir($tpl='') {
      global $conf;
      if(!$tpl) $tpl = $conf['template'];
      return DOKU_INC.'lib/tpl/'.$tpl.'/';
  }
}

if (!function_exists('tpl_basedir')) {
  function tpl_basedir($tpl='') {
      global $conf;
      if(!$tpl) $tpl = $conf['template'];
      return DOKU_BASE.'lib/tpl/'.$tpl.'/';
  }
}

if (!function_exists('tpl_getMediaFile')) {
  function tpl_getMediaFile($search, $abs = false, &$imginfo = null) {
      $img     = '';
      $file    = '';
      $ismedia = false;
      // loop through candidates until a match was found:
      foreach($search as $img) {
          if(substr($img, 0, 1) == ':') {
              $file    = mediaFN($img);
              $ismedia = true;
          } else {
              $file    = tpl_incdir().$img;
              $ismedia = false;
          }

          if(file_exists($file)) break;
      }

      // fetch image data if requested
      if(!is_null($imginfo)) {
          $imginfo = getimagesize($file);
      }

      // build URL
      if($ismedia) {
          $url = ml($img, '', true, '', $abs);
      } else {
          $url = tpl_basedir().$img;
          if($abs) $url = DOKU_URL.substr($url, strlen(DOKU_REL));
      }

      return $url;
  }
}
?><!DOCTYPE html>
<html lang="<?php echo $conf['lang']?>" dir="<?php echo $lang['direction'] ?>" class="popup no-js">
<head>
    <meta charset="utf-8" />
    <!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" /><![endif]-->
    <title>
        <?php echo hsc($lang['mediaselect'])?>
        [<?php echo strip_tags($conf['title'])?>]
    </title>
    <script>(function(H){H.className=H.className.replace(/\bno-js\b/,'js')})(document.documentElement)</script>
    <?php tpl_metaheaders()?>
    <meta name="viewport" content="width=device-width,initial-scale=1" />
    <?php echo tpl_favicon(array('favicon', 'mobile')) ?>
    <?php tpl_includeFile('meta.html') ?>
</head>

<body>
    <!--[if lte IE 7 ]><div id="IE7"><![endif]--><!--[if IE 8 ]><div id="IE8"><![endif]-->
    <div id="media__manager" class="dokuwiki">
        <?php html_msgarea() ?>
        <div id="mediamgr__aside"><div class="pad">
            <h1><?php echo hsc($lang['mediaselect'])?></h1>

            <?php /* keep the id! additional elements are inserted via JS here */?>
            <div id="media__opts"></div>

            <?php tpl_mediaTree() ?>
        </div></div>

        <div id="mediamgr__content"><div class="pad">
            <?php tpl_mediaContent() ?>
        </div></div>
    </div>
    <!--[if ( lte IE 7 | IE 8 ) ]></div><![endif]-->
</body>
</html>
